Bug 1747596 - firebird as dependency?
Summary: firebird as dependency?
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: libreoffice
Version: 30
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Caolan McNamara
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-08-31 02:08 UTC by Harald Reindl
Modified: 2019-10-01 00:01 UTC (History)
7 users (show)

Fixed In Version: libreoffice-6.2.6.2-3.fc30 libreoffice-6.3.2.2-1.fc31
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-09-04 13:58:11 UTC
Type: Bug


Attachments (Terms of Use)

Description Harald Reindl 2019-08-31 02:08:52 UTC
[root@rh:~]$ rpm -e firebird-3.0.4.33054-3.fc30.x86_64 firebird-utils-3.0.4.33054-3.fc30.x86_64 libib-util-3.0.4.33054-3.fc30.x86_64
error: Failed dependencies:
firebird is needed by (installed) libreoffice-core-1:6.2.6.2-2.fc30.x86_64

installed as dependency with the latest libreoffice update

are you kidding me? no need for interbase / firebird the past 20 years and now a simple office suite pulls it?

Comment 1 Caolan McNamara 2019-08-31 12:21:01 UTC
The default database format in 6.2 is firebird embedded (File->New->Database). See bug 1744876 where this has been failing. Database backend is used by more than just the libreoffice-base rpm, e.g. mail merge and other things, so its not certain that a dependency just from -base is sufficient, though we can experiment with that.

Comment 2 Harald Reindl 2019-08-31 13:35:51 UTC
* it can't be used by that much given that i didn't miss it the past 12 years
* libreoffice-emailmerge is not installed here
* libreoffice-kde4 is a bigger problem which needs work on 4 years after kde4 gone


anyways, don't pull dependencies which are not strictly needed, at last *NOT* hard dependencies in these days we have soft ones
in other words leave setups with "install_weak_deps=0" in "dnf.conf" in peace with unesesary bloat

Comment 3 Vitaly Zaitsev 2019-08-31 17:31:31 UTC
Version 1:6.2.6.2-2.fc30 start requiring Firebird server as a direct dependency of libreoffice-core. Previous 6.21 builds - don't.

Comment 4 Caolan McNamara 2019-09-02 08:23:47 UTC
firebird wasn't the default embedded database for the last 12 years, only enabled as such in LibreOffice 6.2 instead of the previous hsqldb solution. Fedora 30 is the first fedora release where this is the case.

libreoffice-emailmerge enables output of mailmerge to email[1], but output to printer/multiple documents still exists regardless. Writer's bibliography feature also uses the database and there is more database related stuff in various places. Its unclear on the face of things what parts of LibreOffice outside of the libreoffice-base application rely implicitly on firebird. In F31 I'm exploring if we can get away with the require just from -base as opposed to -core. In practice it looks like we might get away with it so probably backport of that is on the cards.

kde4 is gone in F31

[1] historically separate just because back in the day Sun had a proprietary solution that was only part of StarOffice

Comment 5 Vitaly Zaitsev 2019-09-02 08:32:58 UTC
> firebird wasn't the default embedded database for the last 12 years, only enabled as such in LibreOffice 6.2 instead of the previous hsqldb solution

But 6.2.6.2-1.fc30 works fine without firebird installed. For the first time the problem appeared in 6.2.6.2-2.fc30.

Comment 6 Harald Reindl 2019-09-02 10:15:35 UTC
> only enabled as such in LibreOffice 6.2 instead of the previous hsqldb solution

so now explain me why hsqldb wasn't a hard dependency back then, wasn't installed accoring to my dist-upgrade log

> But 6.2.6.2-1.fc30 works fine without firebird installed

and that shows it could be a *weak dependency* which would be installd by default except for users knowing what they are doing and disable install_weak_deps

here you go: https://fedoraproject.org/wiki/Packaging:WeakDependencies

Comment 7 Caolan McNamara 2019-09-02 16:06:21 UTC
"6.2.6.2-1.fc30 works fine without firebird installed."

see bug 1744876 for the inscrutable isc_create_database error in F30 base which spawned that change

"so now explain me why hsqldb wasn't a hard dependency back then..."

The hsqldb we were/are using is an old hsqldb 1.8.0 version and we bundle that copy into LibreOffice[1] so we don't have a depend on the newer Fedora system version.

Now... the library providing the firebird integration (libfirebird_sdbclo.so) was listed in %core prior to this change, while the hsqldb driver (and copy of hsqldb.jar) was listed in %base. Taking the position that libfirebird_sdbclo.so was in the correct places implies a firebird depend from core. Initial "experimental" version of libfirebird_sdbclo.so support was added to %core ~2013 and when made non-experimental was left in %core. I will concede that it looks quite like that libfirebird_sdbclo.so can live in %base instead of %core as it looks like the bibliography database and default target format of mail merge and so on look like that are in neither hsqldb or firebird format so will function in the absence of libfirebird_sdbclo.so from %core which is the change building ever so slowly at https://koji.fedoraproject.org/koji/taskinfo?taskID=37421205

"here you go: https://fedoraproject.org/wiki/Packaging:WeakDependencies"

I am aware of weak dependencies, and our help content is a Recommends f.e. and we can gracefully handle its absence, while not so the default file format of base.

[1] The later hsqldb 2.X.Y version changes the file format. The upstream thinking here is something along the lines that if a file format change is required to upgrade hsqldb then its worth trying to migrate away from hsqldb (to firebird) rather than upgrade it, because hsqldb requires java which is problematic in not being guaranteed to be installed on especially Windows machines and bundling java with e.g. the windows install sets is another pile of pain.

Comment 9 Harald Reindl 2019-09-02 16:18:52 UTC
* the real pile of pain is coming up with something like firebird parctically nowhere used in 2019
* for libreoffice-base for the sake of god, ok, not fine, but go ahead
* if anything else is using firebird instead sqlite which is mandatory anyaway it's a design flaw
* no, "one rule them all" for a office-suite is wrong

writer/calc which are the main components used by the mjority of users don't need any database or java at all

Comment 10 Fedora Update System 2019-09-03 11:17:38 UTC
FEDORA-2019-a95452a6e3 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-a95452a6e3

Comment 11 Fedora Update System 2019-09-03 11:17:42 UTC
FEDORA-2019-3859165911 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-3859165911

Comment 12 Fedora Update System 2019-09-03 18:45:51 UTC
libreoffice-6.3.0.4-4.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-3859165911

Comment 13 Fedora Update System 2019-09-04 04:57:59 UTC
libreoffice-6.2.6.2-3.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-a95452a6e3

Comment 14 Harald Reindl 2019-09-04 10:02:11 UTC
thanks for the new build, 25 MB useless deps less which is a lot on it's own and when 10 packages sums up that way it's 250 MB

Comment 15 Fedora Update System 2019-09-04 13:58:11 UTC
libreoffice-6.2.6.2-3.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.

Comment 16 Fedora Update System 2019-09-06 08:06:46 UTC
FEDORA-2019-8619c0859d has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-8619c0859d

Comment 17 Fedora Update System 2019-09-06 10:46:21 UTC
libreoffice-6.3.1.2-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-8619c0859d

Comment 18 Fedora Update System 2019-09-27 07:52:14 UTC
FEDORA-2019-55cf712d09 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-55cf712d09

Comment 19 Fedora Update System 2019-09-28 00:53:18 UTC
libreoffice-6.3.2.2-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-55cf712d09

Comment 20 Fedora Update System 2019-10-01 00:01:04 UTC
libreoffice-6.3.2.2-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.